module ApplicationHelper

  FLASH_NOTICE_KEYS = [:error, :notice, :warning]

  def colorize_in_use_locale(locale)
    @site_in_use_locales.include?(locale)? 'green' : 'red'
  end
  
  def flash_messages
    return unless messages = flash.keys.select{|k| FLASH_NOTICE_KEYS.include?(k)}
    formatted_messages = messages.map do |type|      
      content_tag :div, :class => type.to_s do
        message_for_item(flash[type], flash["#{type}_item".to_sym])
      end
    end
    raw(formatted_messages.join)
  end
  
  def link_back
     link_to t('back'), get_go_back, :class => 'nav'
  end
  
  # Clean the link back
  def get_go_back
    begin
      if request.url.include?('locale=')
        session[:last_page]
      else
        session[:last_page] = remove_locale(request.referer)
      end
    rescue
      eval(params[:controller].split('/').join('_') << '_url')
    end
  end

  # Remove the locale but keep all the other params
  def remove_locale(url)
    target = url.split('?')
    vars = target[1].split('&') rescue []
    vars.delete_if {|var| var.include? 'locale=' }
    if vars.size > 0
      target[0].to_s + '?' + vars.join('&')
    else
      target[0].to_s
    end
  end

  def add_locale(url, locale)
    if url.include?('?')
      url + "&locale=#{locale}"
    else
      url + "?locale=#{locale}"
    end
  end

  def message_for_item(message, item = nil)
    if item.is_a?(Array)
      message % link_to(*item)
    else
      message % item
    end
  end
  
  def add_attribute(partial, f, attribute)
    new_object = f.object.send(attribute).build
    fields = f.fields_for(attribute, new_object, :child_index => "new_#{attribute}") do |f|
      render :partial => partial, :object => new_object, :locals => {:f => f}
    end
  end
  
  def active_for_ob_auths_object(object_class,field = :object_auth_id)
    unless active_for_action("object_auths_new_interface","setting").nil?
      ob_auth = ObjectAuth.find params[field]
      ob_auth.obj_authable_type == object_class.to_s ?  'active' : nil
    end
  end
  
  def active_for_ob_auth(ob_auth_title,field = :object_auth_id)
    unless active_for_action("module_apps_new_interface","setting").nil?
      oa_auth = ObjectAuth.find params[field]
      oa_auth.title == ob_auth_title ?  'active' : nil
    end
  end
  
  def active_for_app_auth(app_title ='', opt={:controller_name => 'module_apps_new_interface',:action_name=>'setting',:field => :module_app_id})
    unless active_for_action(opt[:controller_name],opt[:action_name]).nil?
      app = ModuleApp.find params[opt[:field]]
      app.title == app_title ? 'active' : nil
    else
      nil
    end
  end
  
  def active_for_controllers(*controller_names)
    (controller_names.include?(controller.controller_name) || controller_names.include?(request.fullpath)) ? 'active' : nil
  end

  def visible_for_controllers(*controller_names)
    (controller_names.include?(controller.controller_name) || controller_names.include?(request.fullpath)) ? '' : 'hide'
  end
  
  def active_for_action(controller_name, action_name)
    ((controller.controller_name.eql?(controller_name) || request.fullpath.eql?(controller_name)) && controller.action_name.eql?(action_name)) ? 'active' : nil
  end
  
  def page_metas(page)
    tmp_meta = {}
    metas = ''
    @site.site_metas.each do |meta|
      name, content = meta.get_name_content
      tmp_meta.merge!(name => content)
    end rescue nil
    page.page_metas.each do |meta|
      name, content = meta.get_name_content
      tmp_meta.merge!(name => content)
    end rescue nil
    tmp_meta.each_pair{|name, content|
      metas << "<meta name='#{name}' content='#{content}' />\n"
    } if !tmp_meta.blank?
    metas
  end

  def page_title(page)
    res = "<title>"
    page_title = page.title ? page.title[I18n.locale] : page.i18n_variable[I18n.locale]
    if page.root? && @site.title
      res << @site.title[I18n.locale]
    elsif @site.title && @site.title_always_on
      res << @site.title[I18n.locale] + ' - ' + page_title
    else
      res << page_title
    end
    res << "</title>\n"
  end  

  def page_stylesheets(page, edit=nil)
    stylesheets = ''
    unless edit
      stylesheets << "<link href='/assets/bootstrap.css' rel='stylesheet' type='text/css' />\n" 
      stylesheets << "<link href='/assets/bootstrap-orbit.css' rel='stylesheet' type='text/css' />\n"
      stylesheets << "<link href='/assets/style.css' rel='stylesheet' type='text/css' />\n"
    end
    stylesheets << "<link href='#{page.design.reset_css.file.url}' rel='stylesheet' type='text/css' />\n" if page.design.reset_css
    stylesheets << "<link href='#{asset_path 'banner_nav.css'}' rel='stylesheet' type='text/css' />\n" 
    stylesheets << "<link href='#{page.design.default_css.file.url}' rel='stylesheet' type='text/css' />\n" if page.design.default_css
    theme = page.design.themes.detect{ |d| d.id == page.theme_id }
    stylesheets << "<link href='#{theme.file.url}' rel='stylesheet' type='text/css' />\n" if theme
    stylesheets
  end

  def page_javascripts(page, edit=nil)
    javascripts = ''
    unless edit
      javascripts << "<script type='text/javascript' src='/static/jquery.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/bootstrap.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/jquery.tinyscrollbar.min.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/jquery.isotope.min.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/orbit-bar-member.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/orbit_bar.js'></script>\n"
      javascripts << "<script type='text/javascript' src='/assets/orbit-bar-search.js'></script>\n"
    end
    javascripts << "<script type='text/javascript' src='/static/jquery.cycle.all.latest.js'></script>\n"
    javascripts << "<script type='text/javascript' src='/static/kernel.js'></script>\n"
    javascripts << "<script type='text/javascript' src='/assets/event.js'></script>\n"
    page.design.javascripts.each do |js|
      # javascripts << "<script type='text/javascript' src='#{js.file.url}'></script>"
    end
    javascripts
  end

  def active_when_current_locale_eq(locale)
    locale.to_sym == I18n.locale ? 'active in': ''
  end

  def at_least_module_manager
      is_manager? || is_admin? 
  end
  
  def dislpay_view_count(object)
    "#{t(:view_count)}: #{object.view_count}"
  end

  def display_visitors(options={})
    Impression.where(options).and(:referrer.ne => nil).distinct(:session_hash).count
  end

  def display_visitors_today
    display_visitors(created_at: {'$gte' => Date.today.beginning_of_day, '$lte' => Date.today.end_of_day})
  end

  def display_visitors_this_week
    display_visitors(created_at: {'$gte' => Date.today.beginning_of_week, '$lte' => Date.today.end_of_week})
  end

  def display_visitors_this_month
    display_visitors(created_at: {'$gte' => Date.today.beginning_of_month, '$lte' => Date.today.end_of_month})
  end

  def display_visitors_this_year
    display_visitors(created_at: {'$gte' => Date.today.beginning_of_year, '$lte' => Date.today.end_of_year})
  end

  def at_least_module_manager
    is_manager? || is_admin? 
  end

  def display_date_time(object)
    object.strftime("%Y-%m-%d %H:%M")
  end

  def display_date(object)
    object.strftime("%Y-%m-%d")
  end

end
